"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Interceptor = void 0;
class Interceptor {
    constructor() {
        this.handles = [];
    }
    use(fulfilled, rejected) {
        this.handles.push({ fulfilled, rejected });
        return this.handles.length - 1;
    }
    eject(id) {
        if (this.handles[id]) {
            this.handles[id] = null;
        }
    }
    forEach(fn) {
        this.handles.forEach(interceptor => interceptor && fn(interceptor));
    }
}
exports.Interceptor = Interceptor;
//# sourceMappingURL=Interceptors.js.map