"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Wefetch_defaults, _Wefetch_task;
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const _1 = require(".");
const promisify_1 = require("./promisify");
const Interceptors_1 = require("./Interceptors");
// 'OPTIONS' | 'GET' | 'HEAD' | 'POST' | 'PUT' | 'DELETE' | 'TRACE' | 'CONNECT'
class Wefetch {
    constructor(option) {
        _Wefetch_defaults.set(this, void 0);
        _Wefetch_task.set(this, void 0);
        this.before = new Interceptors_1.Interceptor();
        this.after = new Interceptors_1.Interceptor();
        __classPrivateFieldSet(this, _Wefetch_defaults, option, "f");
    }
    dispatchRequest(option) {
        const promise = __classPrivateFieldGet(this, _Wefetch_defaults, "f").adaptor(option);
        __classPrivateFieldSet(this, _Wefetch_task, promise._task, "f");
        return promise.then(response => response, _1.WrapperPromise.reject);
    }
    register(api) {
        if (!(0, utils_1.isFunction)(api)) {
            throw new Error(`expect a function, but go a $${api}:${typeof api}`);
        }
        __classPrivateFieldGet(this, _Wefetch_defaults, "f").adaptor = (0, promisify_1.promisify)(api);
    }
    cancel() {
        __classPrivateFieldGet(this, _Wefetch_task, "f").abort();
    }
    get task() {
        return __classPrivateFieldGet(this, _Wefetch_task, "f");
    }
    request(option) {
        if ((0, utils_1.isString)(option)) {
            option = arguments[1] || {};
            option.url = arguments[0];
        }
        const chian = [this.dispatchRequest, undefined];
        let promise = _1.WrapperPromise.resolve(option);
        this.before.forEach(interceptor => {
            chian.unshift(interceptor.fulfilled, interceptor.rejected);
        });
        this.after.forEach(interceptor => {
            chian.push(interceptor.fulfilled, interceptor.rejected);
        });
        while (chian.length) {
            promise = promise.then(chian.shift(), chian.shift());
        }
        return promise;
    }
    get(option) {
        return this.request(Object.assign(Object.assign({}, option), { method: 'GET' }));
    }
    head(option) {
        return this.request(Object.assign(Object.assign({}, option), { method: 'HEAD' }));
    }
    post(option) {
        return this.request(Object.assign(Object.assign({}, option), { method: 'POST' }));
    }
    delete(option) {
        return this.request(Object.assign(Object.assign({}, option), { method: 'DELETE' }));
    }
    put(option) {
        return this.request(Object.assign(Object.assign({}, option), { method: 'PUT' }));
    }
    trace(option) {
        return this.request(Object.assign(Object.assign({}, option), { method: 'TRACE' }));
    }
    connect(option) {
        return this.request(Object.assign(Object.assign({}, option), { method: 'CONNECT' }));
    }
}
exports.default = Wefetch;
_Wefetch_defaults = new WeakMap(), _Wefetch_task = new WeakMap();
//# sourceMappingURL=Wefetch.js.map