import { AlipayRequestOption, MethodRequestOption, WechatRequestOption } from '../types';
import { DefaultsOptionType } from '../defaultOptions';
import { WrapperPromise } from '.';
import { RequestTask } from './WrapperPromise';
import { Interceptor } from './Interceptors';
export default class Wefetch {
    #private;
    before: Interceptor;
    after: Interceptor;
    constructor(option: DefaultsOptionType | WechatRequestOption | AlipayRequestOption);
    dispatchRequest(option: WechatRequestOption | AlipayRequestOption): Promise<any>;
    register(api: any): void;
    cancel(): void;
    get task(): RequestTask;
    request<T>(url: string, option: WechatRequestOption | AlipayRequestOption): WrapperPromise<T>;
    request<T>(option: WechatRequestOption | AlipayRequestOption): WrapperPromise<T>;
    get<T>(url: string, option: MethodRequestOption): WrapperPromise<T>;
    get<T>(option: WechatRequestOption | AlipayRequestOption): WrapperPromise<T>;
    head<T>(url: string, option: MethodRequestOption): WrapperPromise<T>;
    head<T>(option: WechatRequestOption | AlipayRequestOption): WrapperPromise<T>;
    post<T>(url: string, option: MethodRequestOption): WrapperPromise<T>;
    post<T>(option: WechatRequestOption | AlipayRequestOption): WrapperPromise<T>;
    delete<T>(url: string, option: MethodRequestOption): WrapperPromise<T>;
    delete<T>(option: WechatRequestOption | AlipayRequestOption): WrapperPromise<T>;
    put<T>(url: string, option: MethodRequestOption): WrapperPromise<T>;
    put<T>(option: WechatRequestOption | AlipayRequestOption): WrapperPromise<T>;
    trace<T>(url: string, option: MethodRequestOption): WrapperPromise<T>;
    trace<T>(option: WechatRequestOption | AlipayRequestOption): WrapperPromise<T>;
    connect<T>(url: string, option: MethodRequestOption): WrapperPromise<T>;
    connect<T>(option: WechatRequestOption | AlipayRequestOption): WrapperPromise<T>;
}
